/***************************************************************************
 *   Copyright (C) 2010 by Volker Lanz <vl@fidra.de>                       *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   51 Franklin Street, Fifth Floor, Boston, MA 02110-1301, USA.          *
 ***************************************************************************/

#include "veneer/actioncollection.h"

#include <QAction>
#include <QDebug>

namespace Veneer
{

ActionCollection::ActionCollection(QObject* parent) :
	QObject(parent)
{
}

QAction* ActionCollection::addAction(const QString& name, QAction* a)
{
// 	qDebug() << "add action " << a << " with name " << name;

	if (a == NULL)
		return NULL;

	m_Actions.append(a);
	m_ActionsByName[name] = a;

	return a;

}

QAction* ActionCollection::addAction(const QString& name, const QObject* recv, const char* slot)
{
	QAction* action = new KAction(QString(), this);

	if (recv != NULL && slot != NULL)
		connect(action, SIGNAL(triggered()), recv, slot);

	return addAction(name, action);
}

QAction* ActionCollection::action(const QString& name)
{
// 	qDebug() << "find action " << name;

	if (m_ActionsByName.find(name) != m_ActionsByName.end())
	{
// 		qDebug() << "got it at " << m_ActionsByName[name];
		return m_ActionsByName[name];
	}

// 	qDebug() << "not found";

	return NULL;
}

}

